
typedef int (*sprite_sigfun_t)(sprite_t *target, int signal, void *data);

struct sprite_sighandler
{
  sprite_sigfun_t fun;
  struct sprite_sighandler *next;
};

void sprite_sighand_init(sprite_t *s);
void sprite_sighand_add(sprite_t *s, sprite_sigfun_t hand);
void sprite_sighand_remove(sprite_t *s, sprite_sigfun_t hand);
void sprite_sighand_remove_all(sprite_t *s);
 int sprite_signal(sprite_t *s, int signal, void *data);

enum sprite_signals
  {
    SIGNAL_IGNORE = 0,
    SIGNAL_FRAMESTART, /* new frame */  
    SIGNAL_ALARM, /* A previously set alarm went off */
    SIGNAL_DEBUG, /* Write info about self to stderr */
    /* SIGNAL_CUSTOM should always be last */
    SIGNAL_CUSTOM
  };
